/*Listener for ToolBar
*/

package uk.ac.ic.doc.y2002.tool.application;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

class AnimateListener extends ToolBarListener implements ActionListener{

    DisplayPane my_display;
    JDesktopPane my_desktop;

    public AnimateListener(Application my_application, JDesktopPane my_desktop) {
	super(my_application);
	this.my_desktop = my_desktop;
    }

    public void actionPerformed(ActionEvent e) {
	try { // see if it was the toolbar button pressed
	    MySelectButton button = (MySelectButton) e.getSource();
	    super.actionPerformed(e);    
	} catch (Exception ex){ // it was the menu item that triggered it
	};


	// get DisplayPane
	EditorFrame my_frame = (EditorFrame) my_desktop.getSelectedFrame();
	
	if (my_frame!=null){
	    this.my_display = my_frame.display;
	            
	    // both toolbar buttons and menu items are derived
	    // from AbstractButton
	    AbstractButton button = (AbstractButton) e.getSource();
	    String cmd = button.getActionCommand();
	            
	    //notify display of button press.
	    if (cmd.equals("animate")){
		my_application.setAnimate(my_frame.inSubnet(),true);
		my_display.animator.setTimestep(my_application.getTimestep());
		my_display.animator.animate();
	    } else if (cmd.equals("pause")) {
		my_display.animator.pause();
	    } else if (cmd.equals("revert")){    
		my_display.animator.revert();
		my_application.setAnimate(my_frame.inSubnet());
	    }
	}
    }
}



