/*	Listener for Edit Menu Copy
*/

package uk.ac.ic.doc.y2002.tool.application;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import org.jdom.*;
import java.util.*;
import uk.ac.ic.doc.y2002.tool.editor.*;

class MenuEditCopyListener implements ActionListener{

    private JDesktopPane desktop; // used to locate current desktop.
    private SelectionBox clip; // list of cut or copied elements. 

    public MenuEditCopyListener(JDesktopPane desktop) {

	this.desktop = desktop;
    }

    public void actionPerformed(ActionEvent e) {

	EditorFrame my_frame = (EditorFrame) desktop.getSelectedFrame();       

	// if we have a selected editor frame.
	if (my_frame != null) {
	    getLabels(my_frame);
	}
    }
 
    private void getLabels(EditorFrame frame) {

	DisplayPane display = frame.display;
	Clipboard myClipboard = display.getClipboard();
	clip = display.mySelection;

	// Add clip to clipboard if not empty clip.
	if (clip != null && clip.getContainedElements().size() > 0) {
	    clip.setCutOffset();
	    myClipboard.addClip(clip);
	}

	display.removeSelectionBox();
    } 
}




