/*	Listener for Edit Menu
*/

package uk.ac.ic.doc.y2002.tool.application;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import org.jdom.*;
import java.util.*;
import uk.ac.ic.doc.y2002.tool.editor.*;

class MenuEditListener implements ActionListener{

    private JDesktopPane desktop; // used to locate current desktop.

    public MenuEditListener(JDesktopPane desktop) {

	this.desktop = desktop;
    }

    public void actionPerformed(ActionEvent e) {

	MyMenuItem item = (MyMenuItem) e.getSource();
	String cmd = item.getActionCommand();
	EditorFrame my_frame = (EditorFrame) desktop.getSelectedFrame();       
	
	// if we have a selected editor frame.
	if (my_frame != null) {
	    
	    if (cmd.equals("cut"))
		cutLabels(my_frame);
	    else if (cmd.equals("paste"))
		pasteLabels(my_frame);
	    else if (cmd.equals("copy"))
		copyLabels(my_frame);
	}
    }
    
    private void cutLabels(EditorFrame frame) {

	DisplayPane display = frame.display;
	// make a copy of hashmaps to avoid concurrent access problems.
	HashMap m = new HashMap(display.idTable);
	Iterator it = m.entrySet().iterator();
      
	while (it.hasNext() ) {

	    Map.Entry e = (Map.Entry) it.next();
	    PNLabel label = (PNLabel) e.getValue();
	    
	    // if PNLabel selected.
	    if (label.returnSelected() ) {
		
		//  TODO paste to clipboard JDOM
		
		// ask display pane to remove PNLabel.
		display.removeLabel(label);
	    }
	}
    } 

    private void pasteLabels(EditorFrame frame) {

    }

    private void copyLabels(EditorFrame frame) {

    }
}








