/*Listener for File Menu - Open
*/

package uk.ac.ic.doc.y2002.tool.application;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

class MenuOpenListener implements ActionListener{

    private Application adaptee;

    public MenuOpenListener(Application adaptee) {

	this.adaptee = adaptee;
    }


    public void actionPerformed(ActionEvent e) {

	// get File name from JFileChooser.
	JFileChooser chooser = new JFileChooser();
	chooser.setCurrentDirectory( new File("./samples"));
	chooser.addChoosableFileFilter(new ExtensionFileFilter());
	int result = chooser.showOpenDialog(adaptee);

	if (result == JFileChooser.APPROVE_OPTION) {

	    // Get selected File.
	    File myFile = chooser.getSelectedFile();

	    // Request document building without validation.
	    SAXBuilder builder = new SAXBuilder(false);

	    try {
		Document doc = builder.build(myFile);
		examineDoc(doc, myFile);
	    }
	    catch (Exception error) { System.out.println("Error - file not read."); }
	}
    }

    // Method to examine loaded JDOM document.
    private void examineDoc(Document doc, File myFile) {

	Element root = doc.getRootElement();
	Namespace ns = root.getNamespace();
	java.util.List net_content = root.getChildren("net", ns);

	Iterator it = net_content.iterator();

	// create new frame on desktop for each net
	while (it.hasNext()) {
	    Element element = (Element) it.next();
	    EditorFrame frame = new EditorFrame(adaptee, doc, element, myFile);
	    frame.setVisible(true);
	    adaptee.desktop.add(frame);
	    try {
		frame.setSelected(true);
	    } catch (java.beans.PropertyVetoException e) {};
	}

	java.util.List sub_content = root.getChildren("module", ns);

	it = sub_content.iterator();

	// create new frame on desktop for each subnet
	while (it.hasNext()) {

	    Element element = (Element) it.next();
	    SubnetFrame frame = new SubnetFrame(adaptee, doc, element, myFile);
	    frame.setVisible(true);
	    adaptee.desktop.add(frame);
	    try {
		frame.setSelected(true);
	    } catch (java.beans.PropertyVetoException e) {};

	}

    }

}
















