/*	Listener for File Menu - SaveAs
*/

package uk.ac.ic.doc.y2002.tool.application;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

class MenuSaveAsListener implements ActionListener{

    private JDesktopPane desktop; // used to locate current desktop.

    public MenuSaveAsListener(JDesktopPane desktop) {

	this.desktop = desktop;
    }

    public void actionPerformed(ActionEvent e) {


	// get JDOM doc
	EditorFrame my_frame = (EditorFrame) desktop.getSelectedFrame();

	// check to make sure a frame is selected!
	if (my_frame != null) {
	    Document doc = my_frame.doc;

	    // get File name from JFileChooser.
	    JFileChooser chooser = new JFileChooser();
	    chooser.setCurrentDirectory( new File("./samples"));
	    chooser.addChoosableFileFilter(new ExtensionFileFilter());
	    int result = chooser.showSaveDialog(desktop);

	    if (result == JFileChooser.APPROVE_OPTION) {

		// Get selected File.
		File myFile = chooser.getSelectedFile();

		// Output to file
		try {
		    FileOutputStream out = new FileOutputStream(myFile);
		    XMLOutputter serializer = new XMLOutputter("   ", true);
		    serializer.output(doc, out);
		    out.flush();
		    out.close();
		}
		catch (IOException error) {
		    System.err.println(error);
		}
		// update the file reference in the editor frame
		my_frame.file = myFile;
		System.out.println("File saved successfully");
	    }
	}

    }

}













