
/*	Listener for File Menu - Save
*/

package uk.ac.ic.doc.y2002.tool.application;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

class MenuSaveListener implements ActionListener{

    private JDesktopPane desktop; // used to locate current desktop.

    public MenuSaveListener(JDesktopPane desktop) {

	this.desktop = desktop;
    }

    public void actionPerformed(ActionEvent e) {

	// get JDOM doc
	EditorFrame my_frame = (EditorFrame) desktop.getSelectedFrame();

	// Check to make sure a frame is selected.
	if (my_frame != null) {

	    Document doc = my_frame.doc;
	    File file = my_frame.file;
	    int result = JFileChooser.APPROVE_OPTION;

	    // if user has not selected a file name
	    if (file.getName().equals("new.xml") || file.getName().equals("newModule.xml")) {

		// get File name from JFileChooser.
		JFileChooser chooser = new JFileChooser();
		chooser.setCurrentDirectory( new File("./samples"));
		chooser.addChoosableFileFilter(new ExtensionFileFilter());
		result = chooser.showSaveDialog(desktop);
		file = chooser.getSelectedFile();
	    }

	    if (result == JFileChooser.APPROVE_OPTION) {

		// Output to file
		try {
		    FileOutputStream out = new FileOutputStream(file);
		    XMLOutputter serializer = new XMLOutputter();
		    serializer.output(doc, out);
		    out.flush();
		    out.close();
		}
		catch (IOException error) {
		    System.err.println(error);
		}
		// update the file reference in the editor frame
		my_frame.file = file;
		System.out.println("File saved successfully.");
	    }
	}
    }
}












