/* MenuItem class used as a template for all menu items
*/

package uk.ac.ic.doc.y2002.tool.application;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

class MyMenuItem extends JMenuItem {
    
    // constructor - no action command
    public MyMenuItem( String label, int mnemonic, int acceleratorKey) {
	
	super(label);			

	if (mnemonic != 0)
	    setMnemonic((char) mnemonic);
	if (acceleratorKey != 0)
	    setAccelerator(KeyStroke.getKeyStroke(acceleratorKey, java.awt.Event.CTRL_MASK));
    }

    // constructor with action command.
    public MyMenuItem( String label, int mnemonic, int acceleratorKey, String command) {
	
	super(label);			

	if (mnemonic != 0)
	    setMnemonic((char) mnemonic);
	if (acceleratorKey != 0)
	    setAccelerator(KeyStroke.getKeyStroke(acceleratorKey, java.awt.Event.CTRL_MASK));

	setActionCommand(command);
    }


    // constructor for menu items with images.
     public MyMenuItem( String label, String image, String command, int mnemonic) {
	
	super(label, new ImageIcon(image));			

	setActionCommand(command);

	if (mnemonic != 0)
	    setMnemonic((char) mnemonic);
    }
}

