/*	Button class used as a template for Selectable ToolBar buttons.
*/

package uk.ac.ic.doc.y2002.tool.application;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

class MySelectButton extends JButton {

    private String selectIcon;
    private String unSelectIcon;

    // Constructor for selectable buttons
    public MySelectButton( String unSelectIcon, String selectIcon, String tooltip, String command ) {

	super( new ImageIcon(unSelectIcon) );
        this.setBorder(BorderFactory.createEtchedBorder());

	this.unSelectIcon = unSelectIcon;
	this.selectIcon = selectIcon;

	setToolTipText( tooltip );
	setActionCommand( command );
	}

    // function to display not selected icon.
    void unSelect() {

	setIcon( new ImageIcon(unSelectIcon));
    }

    // function to display selected icon.
    void select() {

	setIcon( new ImageIcon(selectIcon));
    }
}















