package uk.ac.ic.doc.y2002.tool.editor;

import javax.swing.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;
import uk.ac.ic.doc.y2002.tool.application.*;

/** Custom context (right-click) menu for the ArcLabels.
 * It provides Snap-to-position and Weight-adjusting options.
 */
public class ArcContextMenu extends PetriContextMenu{
    JMenuItem snap, weightUp, weightDown;

    public ArcContextMenu(PNLabel l, Class prop_class) {
	super(l,prop_class);
    }

    protected void buildMenu(){
	super.buildMenu();
	addSnap();
	addWeightUp();
	addWeightDown();
    }

    /** This funtion only adds a menu item for "Snap to position"
     * if the arc isn't already snapping automatically.
     */
    protected void addSnap(){
	ArcLabel a = (ArcLabel) label;
	boolean snapstate = a.getSnap();
	if (snapstate==false) {
	    snap = new JMenuItem("Snap to position");
	    snap.addActionListener( new ActionListener() {
		    public final void actionPerformed(ActionEvent e) {
			ArcLabel a = (ArcLabel) label;
			a.setSnap(true);
			a.positionLines();
			a.getDisplayPane().repaint();
		    }
		});
	    add(snap);
	}
    }

    /** This funtion adds a menu item for "Increase Arc Weight".
     */
    protected void addWeightUp(){
	ArcLabel a = (ArcLabel) label;
	weightUp = new JMenuItem("Increase Arc Weight");
	weightUp.addActionListener( new ActionListener() {
		public final void actionPerformed(ActionEvent e) {
		    ArcLabel a = (ArcLabel) label;
		    a.setWeight(a.getWeight()+1);
		    a.getDisplayPane().repaint();
		}
	    });
	add(weightUp);
    }

    /** This funtion only adds a menu item for "Decrease Arc Weight"
     * if the arc has a weight > 1.
     */
    protected void addWeightDown(){
	ArcLabel a = (ArcLabel) label;
	int weight = a.getWeight();
	if (weight > 1) {
	    weightDown = new JMenuItem("Decrease Arc Weight");
	    weightDown.addActionListener( new ActionListener() {
		    public final void actionPerformed(ActionEvent e) {
			ArcLabel a = (ArcLabel) label;
			a.setWeight(a.getWeight()-1);
			a.getDisplayPane().repaint();
		    }
		});
	    add(weightDown);
	}
    }

}





