package uk.ac.ic.doc.y2002.tool.editor;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

/** The properties box corresponding to the ArcTypedLabel.
 */
public class ArcTypedPropertiesBox extends ArcPropertiesBox {

    public ArcTypedPropertiesBox(Element e) {
        super(e);
    }

    /** Find and add to the panel elements that require special treatment, 
     * and those that should always be available for a particular type of 
     * petri net object.
     * If they're not present, it adds them in with default values.
     * When dealt with, add a reference to the element (if it was the value
     * being displayed) or the attribute to the "specials" HashSet.
     */
    protected void doSpecial(JPanel panel, Element e) {
        super.doSpecial(panel,e);

        String s;
        JTextField field;
	// <type value="arctype" />
	if (element.getChildren("type",ns).size()<=0){
	    element.addContent(new Element("type",ns));
	}
	Element t = element.getChild("type",ns);
	if (t.getAttribute("value")==null) { // attribute not present
	    t.setAttribute("value","normal");
	}
	Attribute a = t.getAttribute("value");
	s = t.getAttributeValue("value");
	if (s.equals("")) a.setValue("normal");
	Vector valids = new Vector();
	valids.add("normal");
	valids.add("read");
	valids.add("inhibitor");
	valids.add("reset");
	JComboBox combo = doAttribute(format("Arc Type:"),panel,t,a,valids);
	combo.setToolTipText("Arc Type: normal, read, inhibitor, reset");
	specials.add(a);
	
    }

    
    
    /** Find those elements which should not be shown in the properties box,
     * and add them to the "hiddens" HashSet.
     */
    protected void doHidden(JPanel panel, Element e) {
	super.doHidden(panel,e);
    } 
    
}





