package uk.ac.ic.doc.y2002.tool.editor;

import javax.swing.JLabel;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;
import uk.ac.ic.doc.y2002.tool.application.*;

public class ImportPlaceLabel extends ReferencePlaceLabel implements MouseListener, MouseMotionListener{
    
    public ImportPlaceLabel(Element e) {
	super(e);
	// set up member variables
	xoffset = radius + offset;
	yoffset = radius + offset;
	
	preferredSize = new Dimension(2*(radius+offset),2*(radius+offset));
    }

    public void updateBounds() {
	setBounds(lastX-(radius+offset),lastY-(radius+offset),2*(radius+offset),2*(radius+offset)+textspace);

    }
    protected void updateLocation(MouseEvent e){
	int x =  getX() + e.getX() - xPress;
	int y =  getY() + e.getY() - yPress;
	if (parentIsModule())
	    y = 7;
	//setPosition(getX() + e.getX() - xPress, getY() + e.getY() - yPress);
	setPosition( x, y);
	repaint();
    }

    // returns true if parent is an interface.
    private boolean parentIsModule() {

	Element parent = element.getParent();
	return parent.getName().equals("interface");
    }


    public void paintComponent(Graphics g){
        super.paintComponent(g);
  

    }
    protected void paintName(Graphics2D g2){
	// Draws the name.
	String name = getName();
	g2.drawString(name,radius/3,2*(radius+offset*2));
    }
    
    // Function to create a new importplace element.
    public static Element makeElement(int x, int y, String id, Namespace ns) {

	Element importPlace = new Element("importPlace", ns);
	importPlace.setAttribute("id", id);
	Element graphics = PNLabel.makeGraphics(String.valueOf(x), String.valueOf(y), ns);
	Element name = NodeLabel.makeName(id, ns);
	
	importPlace.addContent(name);
	importPlace.addContent(graphics);
	
	return importPlace;
    }
}













