package uk.ac.ic.doc.y2002.tool.editor;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

/** The properties box corresponding to the NodeLabel - common
 * properties for places, transitions etc.
 */
public class NodePropertiesBox extends PNPropertiesBox {

    public NodePropertiesBox(Element e) {
        super(e);
    }

    /** Find and add to the panel elements that require special treatment, 
     * and those that should always be available for a particular type of 
     * petri net object.
     * If they're not present, it adds them in with default values.
     * When dealt with, add a reference to the element (if it was the value
     * being displayed) or the attribute to the "specials" HashSet.
     */
    protected void doSpecial(JPanel panel, Element e) {
	super.doSpecial(panel,e);

	String s;
	JTextField field;
	Attribute a;

	// name of element
	// <name><value>textname</value></name>
	if (element.getChildren("name",ns).size()<=0)
	    element.addContent(new Element("name",ns));
	if (element.getChild("name",ns).getChildren("value",ns).size()<=0)
	    element.getChild("name",ns).addContent(new Element("value",ns));
	Element namev = element.getChild("name",ns).getChild("value",ns);
	s = namev.getTextTrim();
	if (s==null) namev.setText("");
	field = doTextContent(format("Name:"), panel, namev);
	field.setToolTipText("Descriptive Name of the element: not the same as the unique id!");
	specials.add(namev);
	
    }    
    
    /** Find those elements which should not be shown in the properties box,
     * and add them to the "hiddens" HashSet.
     */
    protected void doHidden(JPanel panel, Element e) {
	super.doHidden(panel,e);
	
	Element el;
	
	// <name><graphics><offset x="0" y="0" page="1" /></graphics></name>
	// ie everything below graphics (except stuff specified in doSpecial)
	if (element.getChildren("name",ns).size()>0)
	    if (element.getChild("name",ns)
		.getChildren("graphics",ns).size()>0){
		el = element.getChild("name",ns).getChild("graphics",ns);
		if (el!=null) hiddens.add(el);   
	    }
	
    } 
    
}





