package uk.ac.ic.doc.y2002.tool.editor;

import javax.swing.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;
import uk.ac.ic.doc.y2002.tool.application.*;

/** Custom context (right-click) menu for the Places.
 * It provides Token-adjusting options.
 */
public class PlaceContextMenu extends PetriContextMenu{
    JMenuItem snap, tokenUp, tokenDown;

    public PlaceContextMenu(PNLabel l, Class prop_class) {
	super(l,prop_class);
    }

    protected void buildMenu(){
	super.buildMenu();
	addTokenUp();
	addTokenDown();
    }

    /** This funtion adds a menu item for "Add Token".
     */
    protected void addTokenUp(){
	tokenUp = new JMenuItem("Add Token");
	tokenUp.addActionListener( new ActionListener() {
		public final void actionPerformed(ActionEvent e) {
		    label.addToken();
		    label.getDisplayPane().repaint();
		}
	    });
	add(tokenUp);
    }

    /** This funtion only adds a menu item for "Decrease Arc Weight"
     * if the arc has a weight > 1.
     */
    protected void addTokenDown(){
	PlaceLabel p = (PlaceLabel) label;
	int tokens = p.getMarking();
	if (tokens > 0) {
	    tokenDown = new JMenuItem("Remove Token");
	    tokenDown.addActionListener( new ActionListener() {
		    public final void actionPerformed(ActionEvent e) {
			label.remToken();
			label.getDisplayPane().repaint();
		    }
		});
	    add(tokenDown);
	}
    }

}





