package uk.ac.ic.doc.y2002.tool.editor;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

/** The properties box corresponding to the PlaceLabel.
 */
public class PlacePropertiesBox extends NodePropertiesBox {

    public PlacePropertiesBox(Element e) {
        super(e);
    }

    /** Find and add to the panel elements that require special treatment, 
     * and those that should always be available for a particular type of 
     * petri net object.
     * If they're not present, it adds them in with default values.
     * When dealt with, add a reference to the element (if it was the value
     * being displayed) or the attribute to the "specials" HashSet.
     */
    protected void doSpecial(JPanel panel, Element e) {
	super.doSpecial(panel,e);

	String s;
	JTextField field;
	Attribute a;

	// marking of element (no. of tokens)
	// <initialMarking><value>textname</value></initialMarking>
	if (element.getChildren("initialMarking",ns).size()<=0)
	    element.addContent(new Element("initialMarking",ns));
	if (element.getChild("initialMarking",ns).getChildren("value",ns).size()<=0)
	    element.getChild("initialMarking",ns).addContent(new Element("value",ns));
	Element tokensv = element.getChild("initialMarking",ns).getChild("value",ns);
	s = tokensv.getTextTrim();
	if (s==null) tokensv.setText("");
	field = doTextContent(format("Marking:"), panel, tokensv);
	field.setToolTipText("Number of tokens on the element");
	specials.add(tokensv);
	
    }    
    
    /** Find those elements which should not be shown in the properties box,
     * and add them to the "hiddens" HashSet.
     */
    protected void doHidden(JPanel panel, Element e) {
	super.doHidden(panel,e);
	
	Element el;
	// <initialMarking><graphics><offset x="0" y="0" page="1" /></graphics></initialMarking>
	// ie everything below graphics (except stuff specified in doSpecial)
	if (element.getChildren("initialMarking",ns).size()>0)
	    if (element.getChild("initialMarking",ns)
		.getChildren("graphics",ns).size()>0){
		el = element.getChild("initialMarking",ns).getChild("graphics",ns);
		hiddens.add(el);  
	    }
    } 
    
}





