package uk.ac.ic.doc.y2002.tool.editor;

import javax.swing.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;
import uk.ac.ic.doc.y2002.tool.application.*;

/** Custom context (right-click) menu for the Subnets.
 * It provides options to open subnet templates and instances.
 */
public class SubnetContextMenu extends PetriContextMenu{
    JMenuItem openTemplate, openInstance;

    public SubnetContextMenu(PNLabel l, Class prop_class) {
	super(l,prop_class);
    }

    protected void buildMenu(){
	super.buildMenu();
	addOpenTemplate();
	addOpenInstance();
    }

    /** This funtion adds a menu item for "Open subnet template"
     */
    protected void addOpenTemplate(){
	openTemplate = new JMenuItem("Open subnet template");
	openTemplate.addActionListener( new ActionListener() {
		public final void actionPerformed(ActionEvent e) {
		    /* check to see if the template is already open, if it
		     * is make that frame active, otherwise open the file
		     */
		    String temp = label.element.getAttributeValue("ref");
		    int index = temp.indexOf('#');
		    String fileRef = temp.substring(0, index);
		    boolean found = false;
		    JDesktopPane desktop = label.getDisplayPane().eframe.getDesktopPane();
		    java.util.List editorFrames;
		    editorFrames = java.util.Arrays.asList((JInternalFrame[]) desktop.getAllFrames());
		    Iterator ei = editorFrames.iterator();
		    while(ei.hasNext()){
			EditorFrame ef = (EditorFrame)ei.next();
			if (ef.root.getName().equals("module")){
			    String fileName = ef.file.getPath();
			    if (ef.file.getPath().equals(fileRef)){
				try{
				    ef.setSelected(true);
				    found = true;
				}catch(java.beans.PropertyVetoException x){
				    System.out.println("SubnetContextMenu:: " + x);
				}
			    }
			}
		    }
		    if (!found){
			SubnetLabel l = (SubnetLabel) label;
			l.openSubnetTemplate();
			System.out.println("Open the subnet template");
			label.getDisplayPane().repaint();
		    }
		}
	    });
	add(openTemplate);
    }

    /**This function adds a menu item for "Open subnet instance"  
     */

    protected void addOpenInstance(){
	openInstance = new JMenuItem("Open subnet instance");
	openInstance.addActionListener( new ActionListener() {
		public final void actionPerformed(ActionEvent e) {
		    SubnetLabel l = (SubnetLabel) label;
		    l.openSubnetInstance();
		    label.getDisplayPane().repaint();
		}
	    });
	add(openInstance);
    }
    
}

















