package uk.ac.ic.doc.y2002.tool.editor;

import javax.swing.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;
import uk.ac.ic.doc.y2002.tool.application.*;

/** The TransitionContextMenu adds functionality to the basic
 * PetriContextMenu, allowing the user to Rotate a transition
 * and Fire an enabled transition.
 */
public class TransitionContextMenu extends PetriContextMenu{
    JMenuItem fire;
    JMenuItem rotateItem;
    JMenuItem highlight;

    public TransitionContextMenu(PNLabel l, Class prop_class) {
	super(l,prop_class);
    }

    protected void buildMenu(){
	super.buildMenu();
	addRotate();
	if (label.isActive())
	    addFire();
    }

    protected void addFire(){
	fire = new JMenuItem("Fire");
	fire.addActionListener( new ActionListener() {
		public final void actionPerformed(ActionEvent e) {
		    TransitionLabel t = (TransitionLabel) label;
		    t.fire();
		    t.getDisplayPane().repaint();
		}
	    });
	add(fire);
    }

    protected void addRotate(){
	rotateItem = new JMenuItem("Rotate");
	rotateItem.addActionListener( new ActionListener() {
		public final void actionPerformed(ActionEvent e) {
		    TransitionLabel t = (TransitionLabel) label;
		    t.setRotation(t.getRotation() + 45);
		    t.repaint();
		}
	    });
	add(rotateItem);
    }


}





