package uk.ac.ic.doc.y2002.tool.editor;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

/** The properties box corresponding to the TransitionStochasticLabel.
 */
public class TransitionStochasticPropertiesBox extends NodePropertiesBox {

    public TransitionStochasticPropertiesBox(Element e) {
        super(e);
    }

    /** Find and add to the panel elements that require special treatment, 
     * and those that should always be available for a particular type of 
     * petri net object.
     * If they're not present, it adds them in with default values.
     * When dealt with, add a reference to the element (if it was the value
     * being displayed) or the attribute to the "specials" HashSet.
     */
    protected void doSpecial(JPanel panel, Element e) {
        super.doSpecial(panel,e);

        String s;
        JTextField field;
	// <type name="transitiontype" />
	if (element.getChildren("type",ns).size()<=0){
	    element.addContent(new Element("type",ns));
	}
	Element t = element.getChild("type",ns);
	if (t.getAttribute("name")==null) { // attribute not present
	    t.setAttribute("name","immediate");
	}
	Attribute a = t.getAttribute("name");
	s = t.getAttributeValue("name");
	if (s.equals("")) a.setValue("immediate");
	Vector valids = new Vector();
	valids.add("timed");
	valids.add("immediate");
	JComboBox combo = doAttribute(format("Transition Type:"),panel,t,a,valids);
	combo.setToolTipText("Transition Type: immediate or timed");
	specials.add(a);

	// <weight>1.0</weight>
	if (element.getChildren("weight",ns).size()<=0){
	    element.addContent(new Element("weight",ns));
	}
	t = element.getChild("weight",ns);
	String w = t.getTextTrim();
	if (w==null || w.equals("")) { // value not set
	    t.setText("1.0");
	}
	w = t.getTextTrim();
	String desc;
	// s is left over from earlier: it should be "timed" or "immediate"
	if (s.equals("immediate")) desc = "Firing priority:";
	else desc = "Firing rate:";
	field = doTextContent(format(desc),panel,t);
	field.setToolTipText("Transition priority (if immediate) or firing rate (if timed)");
	specials.add(t);

    }

    
    
    /** Find those elements which should not be shown in the properties box,
     * and add them to the "hiddens" HashSet.
     */
    protected void doHidden(JPanel panel, Element e) {
	super.doHidden(panel,e);
    } 
    
}





